Configure MySQL on macOS

This is a followup post to my earlier Configure Apache and PHP-FPM on macOS post. With the addition of MySQL to my Mac website development environment, I can now install Content Management Systems, such as WordPress that require a database system to function. My original post supports static website development (for example, Grav). My current website host, Pair Networks, uses MySQL versions 5.6 and 5.7 (seems to default to 5.6). I am creating a similar environment on my Mac. My Altoplace website uses MySQL 5.7, so this post will describe MySQL 5.7. This version is supported by WordPress.

We will again use Homebrew to install MySQL version 5.7. It is very easy to install a working database system with Homebrew. I will describe some tweaks that I made to my MySQL environment. I created a shell script that I use to start, stop, restart, and get process information about my running MySQL service. Homebrew provides a command (brew services …) for starting and stopping a service, but I like having additional error checking and control that I can do in a shell script.

Installing MySQL 5.7 with the brew command

The following shows how to install MySQL 5.7 and how to start up the MySQL service, using the brew services command.

$ brew install mysql@5.7

$ brew link mysql@5.7 --force --overwrite

$ which mysql
/usr/local/bin/mysql

$ brew services list
Name      Status  User   Plist
httpd     started root   /Library/LaunchDaemons/homebrew.mxcl.httpd.plist
mysql@5.7 stopped
php       stopped
php@7.4   started george /Users/george/Library/LaunchAgents/homebrew.mxcl.php@7.4.plist

$ brew services start mysql@5.7
==> Successfully started `mysql@5.7` (label: homebrew.mxcl.mysql@5.6)

$ mysql -u root
Welcome to the MySQL monitor.  Commands end with ; or g.
Your MySQL connection id is 2
Server version: 5.7.34 Homebrew

Copyright (c) 2000, 2021, Oracle and/or its affiliates. All rights reserved.

Oracle is a registered trademark of Oracle Corporation and/or its
affiliates. Other names may be trademarks of their respective
owners.

Type 'help;' or 'h' for help. Type 'c' to clear the current input statement.

mysql> q
Bye
$
Code language: Shell Session (shell)

The default Homebrew MySQL installation does not require a root password. While this may be fine for a local development environment, I recommend running mysql_secure_installation to create a root password and to secure your MySQL installation. After creating your root password, answer Y to all the remaining questions. After doing so, you will have to use your root password to connect to MySQL:

$ mysql -u root
ERROR 1045 (28000): Access denied for user 'root'@'localhost' (using password: NO)

$ mysql -u root -p
Enter password:
Welcome to the MySQL monitor.  Commands end with ; or g.
Your MySQL connection id is 14
Server version: 5.6.47 Homebrew
 o o o
Code language: Shell Session (shell)

Using a Shell Script to Control the MySQL Service

I mention that I wrote a shell script, mydbctl, to control and monitor my MySQL service. The usage looks like:

$ mydbctl
Usage: mydbctl start|stop|restart|status

$ mydbctl start
mysql started OK ...

$ mydbctl status
USER               PID STARTED     ELAPSED      TIME NI      VSZ    RSS COMMAND
george           36070  4:16PM       00:08   0:00.02  0  4282236   1220 /bin/sh /usr/local/opt/mysql@5.7/bin/mysqld_safe --datadir=/usr/local/var/mysql
george           36158  4:16PM       00:08   0:00.26  0  5118812 177464 /usr/local/opt/mysql@5.7/bin/mysqld --basedir=/usr/local/opt/mysql@5.7 --datadir=/usr/local/var/mysql --plugin-dir=/usr/local/opt/mysql@5.7/lib/plugin --log-error=imac1.err --pid-file=imac1.pid

$ mydbctl restart
waiting for mysql to stop 0 ...
waiting for mysql to stop 1 ...
mysql stopped OK ...
mysql started OK ...

$ mydbctl stop   
waiting for mysql to stop 0 ...
waiting for mysql to stop 1 ...
mysql stopped OK ...
Code language: Shell Session (shell)

While this shell script supports the same actions as the brew services command, it actually verifies that the service stopped and/or started successfully. Here is my mydbctl shell script:

#!/bin/zsh

# Usage: mydbctl start|stop|restart|status

error_exit()
{
  echo -e "$1" 1>&2
  exit 1
}

# Usage
if [[ ! $# -eq 1 || ! ($1 == "start" || $1 == "stop" || $1 == "restart" || $1 == "status") ]]
then
  error_exit "Usage: mydbctl start|stop|restart|status"
else
  action="$1"
fi

pwait()
{
  process=$1
  action=$2
  count=0

  if [[ $action == "stop" ]]
  then
    until ! pgrep -q $process || [[ $count -gt 5 ]]
    do
      echo "waiting for $process to stop $count ..."
      sleep 1
      ((count++))
    done
    if ! pgrep -q $process; then
      echo "$process stopped OK ..."
    else
      error_exit "$process failed to stop"
    fi
  else
    # action is start
    sleep 1 # give process time to die for configuration file errors ...
    until pgrep -q $process || [[ $count -gt 5 ]]
    do
      echo "waiting for $process to start $count ..."
      sleep 1
      ((count++))
    done
    if pgrep -q $process; then
      echo "$process started OK ..."
    else
      error_exit "$process failed to start"
    fi
  fi
}

mydb_start()
{
  if pgrep -q mysqld; then
    echo "mysql is already started ..."
    exit 0
  fi

  if [ ! -f "/usr/local/opt/mysql@5.7/homebrew.mxcl.mysql@5.7.plist" ]; then
    error_exit "Cannot start mysql -- homebrew.mxcl.mysql@5.7.plist is missing ..."
  fi

  cp /usr/local/opt/mysql@5.7/homebrew.mxcl.mysql@5.7.plist ~/Library/LaunchAgents/
  if [ "$?" != "0" ]; then
    error_exit "homebrew.mxcl.mysql@5.7.plist copy failed ..."
  fi

  launchctl load ~/Library/LaunchAgents/homebrew.mxcl.mysql@5.7.plist > /dev/null 2>&1
  pwait mysql start
}

mydb_stop()
{
  if ! pgrep -q mysqld; then
    echo "mysql is already stopped ..."
    exit 0
  fi

  launchctl unload ~/Library/LaunchAgents/homebrew.mxcl.mysql@5.7.plist > /dev/null 2>&1
  pwait mysql stop

  # Don't start automatically
  rm -f ~/Library/LaunchAgents/homebrew.mxcl.mysql@5.7.plist
}

mydb_restart()
{
  # First, stop mysql ...
  if ! pgrep -q mysqld; then
    echo "mysql is already stopped, so just start it up ..."
    mydb_start
    exit 0
  fi

  launchctl unload ~/Library/LaunchAgents/homebrew.mxcl.mysql@5.7.plist > /dev/null 2>&1
  pwait mysql stop

  # Then, start mysql ...
  launchctl load ~/Library/LaunchAgents/homebrew.mxcl.mysql@5.7.plist > /dev/null 2>&1
  pwait mysql start
}

mydb_status()
{
  # Get info about running mysql processes
  ps -axo user,pid,start,etime,time,nice,vsz,rss,command |
    egrep 'PID|mysql' | sed '/grep/d'
}

case $action in
  "start")
    mydb_start
    ;;
  "stop")
    mydb_stop
    ;;
  "restart")
    mydb_restart
    ;;
  "status")
    mydb_status
    ;;
  *)
    # Should never happen ...
    error_exit "Invalid action ..."
    ;;
esac

exit 0
Code language: Bash (bash)

There is additional error checking, including actually waiting for the MySQL service to start or stop. This shell script is completely compatible with the brew services actions, for example:

$ brew services list
Name      Status  User   Plist
dnsmasq   unknown root   /Library/LaunchDaemons/homebrew.mxcl.dnsmasq.plist
httpd     unknown root   /Library/LaunchDaemons/homebrew.mxcl.httpd.plist
mysql@5.7 started george /Users/george/Library/LaunchAgents/homebrew.mxcl.mysql@5.7.plist
php       stopped        
php@7.4   started george /Users/george/Library/LaunchAgents/homebrew.mxcl.php@7.4.plist

$ brew services stop mysql@5.7
Stopping `mysql@5.7`... (might take a while)
==> Successfully stopped `mysql@5.7` (label: homebrew.mxcl.mysql@5.7)

$ brew services list          
Name      Status  User   Plist
dnsmasq   unknown root   /Library/LaunchDaemons/homebrew.mxcl.dnsmasq.plist
httpd     unknown root   /Library/LaunchDaemons/homebrew.mxcl.httpd.plist
mysql@5.7 stopped        
php       stopped        
php@7.4   started george /Users/george/Library/LaunchAgents/homebrew.mxcl.php@7.4.plist

$ mydbctl status
USER               PID STARTED     ELAPSED      TIME NI      VSZ    RSS COMMAND
Code language: Shell Session (shell)

You can try both and decide what works for you. I have seen instances where the brew services restart action said that it was successful, but the MySQL service did not actually start up. The mydbctl script verifies that the service process is running (or not) before reporting success. (httpd & dnsmasq show an unknown status because they were started using sudo.)

MySQL Configuration Tweaks

This section is totally optional, but I wanted to make some very basic optimizations before I started creating databases. The MySQL installation creates a my.cnf configuration file at /usr/local/etc. The default content is:

# Default Homebrew MySQL server config
[mysqld]
# Only allow connections from localhost
bind-address = 127.0.0.1
Code language: Shell Session (shell)

I added the following lines after spending some time researching some basic MySQL optimizations. You can do your own research and/or try out these settings. So far, they have been working well for me. However, I have not stressed out my database installations yet. I added the following lines:

# My additions
max_allowed_packet = 64M
innodb_buffer_pool_size = 1024M
innodb_log_file_size = 128M
innodb_buffer_pool_instances = 1

[mysqldump]
max_allowed_packet = 64M
Code language: Shell Session (shell)

Of course, be sure to restart the MySQL service after making any changes to this file. I made several very basic tweaks. The default max allowed packet is very low (4M); I picked a typical value that I have often seen used in various posts. I increased the total in RAM MySQL cache size from 128M to 1024M. I understand that the log file size (times 2) should be 25% of the cache size. Learning how to use MySQL is a big learning curve for me; as my knowledge grows, I will update this post.

Encrypt MySQL user/password credentials

There are times when you may want to execute mysql in a shell script. For example, I have written a shell script called mydbdrop to delete all the tables in a database. You might want to do this, for example, before reinstalling a fresh copy of WordPress. You do not want to hardcode or use your database password in a shell script. You also do not want to be prompted for the password, especially if mysql is being executed in a loop to drop each database table. The solution is to use the mysql_config_editor utility to store authentication credentials in an obfuscated login path file named ~/.mylogin.cnf. You execute mysql_config_editor once with the set action to create an alias (called a login-path) for your user/password/host. Here is an example:


$ mysql_config_editor set --login-path=ap509adm --host=localhost --user=root --password    
Enter password: 

$ ls -l ~/.mylogin.cnf
-rw------- 1 george  staff  136 May 14 16:40 /Users/george/.mylogin.cnf

$ mysql_config_editor print --all                                                      
[ap509adm]
user = root
password = *****
host = localhost
Code language: Shell Session (shell)

The ap509adm alias is called a login-path. I can now use my login-path to connect to mysql without having to specify my user/password/host information. My user credentials are stored in a binary file that’s only readable or writeable by the user. Here is an example of how to use it:

$ mysql --login-path=ap509adm
Welcome to the MySQL monitor.  Commands end with ; or g.
Your MySQL connection id is 3
Server version: 5.7.34 Homebrew

Copyright (c) 2000, 2021, Oracle and/or its affiliates.

Oracle is a registered trademark of Oracle Corporation and/or itsShe
affiliates. Other names may be trademarks of their respective
owners.

Type 'help;' or 'h' for help. Type 'c' to clear the current input statement.

mysql> q
Bye
Code language: Shell Session (shell)

You can add the credentials for other databases to the same ~/.mylogin.cnf file. Just specify a unique login-path or alias for it. Here is an example of how I use mysql in a shell script, mydbdrop, to drop all the tables in a database:

$ mydbdrop
Usage: mydbdrop login-path DB
 Drop all tables from an MySQL database.

$ mydbdrop ap509adm wp509db
Deleting wp_commentmeta table from wp509db database...
Deleting wp_comments table from wp509db database...
Deleting wp_links table from wp509db database...
Deleting wp_options table from wp509db database...
Deleting wp_postmeta table from wp509db database...
Deleting wp_posts table from wp509db database...
Deleting wp_term_relationships table from wp509db database...
Deleting wp_term_taxonomy table from wp509db database...
Deleting wp_termmeta table from wp509db database...
Deleting wp_terms table from wp509db database...
Deleting wp_usermeta table from wp509db database...
Deleting wp_users table from wp509db database...
Code language: Shell Session (shell)

I don’t have to recreate my database. I can delete all the data by dropping all the tables. This can be a dangerous script to use. Be sure you know what your are doing and always have database backups just in case. After dropping all the tables, I am ready to do, for example, a fresh install of WordPress. If this sounds useful to you, here is my mydbdrop script:

#!/bin/zsh

# mydbdrop login-path DB
mylp="$1"
mydb="$2"

# Usage
if [ ! $# -eq 2 ]
then
  echo "Usage: mydbdrop login-path DB"
  echo " Drop all tables from an MySQL database."
  exit 0
fi

tables=$(mysql --login-path=$mylp $mydb -sN -e 'show tables')
if [ $? -ne 0 ]
then
  echo "Error - Cannot connect to mysql server usingn given login-path or database does not exits!"
  exit 1
fi

# make sure one or more tables exists
if [ -z ${tables} ]
then
  echo "Warning - No table found in $mydb database!"
  exit 0
fi

# Delete all the tables in the DB
for t in ${=tables}
do
  echo "Deleting $t table from $mydb database..."
  mysql --login-path=$mylp $mydb -e "drop table $t" > /dev/null 2>&1
  if [ $? -ne 0 ]
  then
   echo "Error - Could not delete table $t!"
   exit 1
  fi
done
Code language: Bash (bash)

Final Thoughts

At this point, you should have a working MySQL environment and are ready to start creating databases, for example a WordPress database, on your local Mac machine. I haven’t tried MySQL version 8.0 yet. But the installation process should be similar. Homebrew defaults to version 8.0 (when doing brew install mysql). I am going to continue getting my feet wet with version 5.7 for now, since I am still in the learning mode and that is the version being used by this website, Altoplace.

Now that I have a complete MAPM stack (macOS, Apache, PHP, and MySQL) environment, I will soon write a post about how to install and use WordPress on a Mac machine.

Leave a Comment

This site uses Akismet to reduce spam. Learn how your comment data is processed.